Loading...
Searching...
No Matches
irr::scene::ITerrainSceneNode Class Referenceabstract

A scene node for displaying terrain using the geo mip map algorithm. More...

`#include <ITerrainSceneNode.h>`

Inheritance diagram for irr::scene::ITerrainSceneNode:

## Public Member Functions

| ITerrainSceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id, const core::vector3df &position=core::vector3df(0.0f, 0.0f, 0.0f), const core::vector3df &rotation=core::vector3df(0.0f, 0.0f, 0.0f), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual const core::aabbox3d< f32 > & | getBoundingBox () const =0
| Get the bounding box of the terrain.
virtual const core::aabbox3d< f32 > & | getBoundingBox (s32 patchX, s32 patchZ) const =0
| Get the bounding box of a patch.
virtual s32 | getCurrentLODOfPatches (core::array< s32 > &LODs) const =0
| Populates an array with the CurrentLOD of each patch.
virtual f32 | getHeight (f32 x, f32 y) const =0
| Get height of a point of the terrain.
virtual u32 | getIndexCount () const =0
| Get the number of indices currently in the meshbuffer.
virtual s32 | getIndicesForPatch (core::array< u32 > &indices, s32 patchX, s32 patchZ, s32 LOD=0)=0
| Gets the indices for a specified patch at a specified Level of Detail.
virtual IMesh * | getMesh ()=0
| Get pointer to the mesh.
virtual void | getMeshBufferForLOD (IDynamicMeshBuffer &mb, s32 LOD=0) const =0
| Gets the meshbuffer data based on a specified level of detail.
virtual IMeshBuffer * | getRenderBuffer ()=0
| Get pointer to the buffer used by the terrain (most users will not need this).
virtual const core::vector3df & | getTerrainCenter () const =0
| Get center of terrain.
virtual bool | loadHeightMap (io::IReadFile *file, video::SColor vertexColor=video::SColor(255, 255, 255, 255), s32 smoothFactor=0)=0
| Initializes the terrain data. Loads the vertices from the heightMapFile.
virtual bool | loadHeightMapRAW (io::IReadFile *file, s32 bitsPerPixel=16, bool signedData=false, bool floatVals=false, s32 width=0, video::SColor vertexColor=video::SColor(255, 255, 255, 255), s32 smoothFactor=0)=0
| Initializes the terrain data. Loads the vertices from the heightMapFile.
virtual bool | overrideLODDistance (s32 LOD, f64 newDistance)=0
| Override the default generation of distance thresholds.
virtual void | scaleTexture (f32 scale=1.0f, f32 scale2=0.0f)=0
| Scales the base texture, similar to makePlanarTextureMapping.
virtual void | setCameraMovementDelta (f32 delta)=0
| Sets the movement camera threshold.
virtual void | setCameraRotationDelta (f32 delta)=0
| Sets the rotation camera threshold.
virtual void | setDynamicSelectorUpdate (bool bVal)=0
| Sets whether or not the node should dynamically update its associated selector when the geomipmap data changes.
virtual void | setLODOfPatch (s32 patchX, s32 patchZ, s32 LOD=0)=0
| Manually sets the LOD of a patch.
Public Member Functions inherited from irr::scene::ISceneNode
| ISceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id=-1, const core::vector3df &position=core::vector3df(0, 0, 0), const core::vector3df &rotation=core::vector3df(0, 0, 0), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual | ~ISceneNode ()
| Destructor.
virtual void | addAnimator (ISceneNodeAnimator *animator)
| Adds an animator which should animate this node.
virtual void | addChild (ISceneNode *child)
| Adds a child to this scene node.
virtual ISceneNode * | clone (ISceneNode *newParent=0, ISceneManager *newManager=0)
| Creates a clone of this scene node and its children.
virtual void | deserializeAttributes (io::IAttributes *in, io::SAttributeReadWriteOptions *options=0)
| Reads attributes of the scene node.
virtual core::vector3df | getAbsolutePosition () const
| Gets the absolute position of the node in world coordinates.
virtual const core::matrix4 & | getAbsoluteTransformation () const
| Get the absolute transformation of the node. Is recalculated every OnAnimate()-call.
const core::list< ISceneNodeAnimator * > & | getAnimators () const
| Get a list of all scene node animators.
u32 | getAutomaticCulling () const
| Gets the automatic culling state.
const core::list< ISceneNode * > & | getChildren () const
| Returns a const reference to the list of all children.
virtual s32 | getID () const
| Get the id of the scene node.
virtual video::SMaterial & | getMaterial (u32 num)
| Returns the material based on the zero based index i.
virtual u32 | getMaterialCount () const
| Get amount of materials used by this scene node.
virtual const c8 * | getName () const
| Returns the name of the node.
scene::ISceneNode * | getParent () const
| Returns the parent of this scene node.
virtual const core::vector3df & | getPosition () const
| Gets the position of the node relative to its parent.
virtual core::matrix4 | getRelativeTransformation () const
| Returns the relative transformation of the scene node.
virtual const core::vector3df & | getRotation () const
| Gets the rotation of the node relative to its parent.
virtual const core::vector3df & | getScale () const
| Gets the scale of the scene node relative to its parent.
virtual ISceneManager * | getSceneManager (void) const
| Retrieve the scene manager for this node.
virtual const core::aabbox3d< f32 > | getTransformedBoundingBox () const
| Get the axis aligned, transformed and animated absolute bounding box of this node.
virtual ITriangleSelector * | getTriangleSelector () const
| Returns the triangle selector attached to this scene node.
virtual ESCENE_NODE_TYPE | getType () const
| Returns type of the scene node.
u32 | isDebugDataVisible () const
| Returns if debug data like bounding boxes are drawn.
bool | isDebugObject () const
| Returns if this scene node is a debug object.
virtual bool | isTrulyVisible () const
| Check whether the node is truly visible, taking into accounts its parents' visibility.
virtual bool | isVisible () const
| Returns whether the node should be visible (if all of its parents are visible).
virtual void | OnAnimate (u32 timeMs)
| OnAnimate() is called just before rendering the whole scene.
virtual void | OnRegisterSceneNode ()
| This method is called just before the rendering process of the whole scene.
virtual void | remove ()
| Removes this scene node from the scene.
virtual void | removeAll ()
| Removes all children of this scene node.
virtual void | removeAnimator (ISceneNodeAnimator *animator)
| Removes an animator from this scene node.
virtual void | removeAnimators ()
| Removes all animators from this scene node.
virtual bool | removeChild (ISceneNode *child)
| Removes a child from this scene node.
virtual void | render ()=0
| Renders the node.
virtual void | serializeAttributes (io::IAttributes *out, io::SAttributeReadWriteOptions *options=0) const
| Writes attributes of the scene node.
void | setAutomaticCulling (u32 state)
| Enables or disables automatic culling based on the bounding box.
virtual void | setDebugDataVisible (u32 state)
| Sets if debug data like bounding boxes should be drawn.
virtual void | setID (s32 id)
| Sets the id of the scene node.
void | setIsDebugObject (bool debugObject)
| Sets if this scene node is a debug object.
void | setMaterialFlag (video::E_MATERIAL_FLAG flag, bool newvalue)
| Sets all material flags at once to a new value.
void | setMaterialTexture (u32 textureLayer, video::ITexture *texture)
| Sets the texture of the specified layer in all materials of this scene node to the new texture.
void | setMaterialType (video::E_MATERIAL_TYPE newType)
| Sets the material type of all materials in this scene node to a new material type.
virtual void | setName (const c8 *name)
| Sets the name of the node.
virtual void | setName (const core::stringc &name)
| Sets the name of the node.
virtual void | setParent (ISceneNode *newParent)
| Changes the parent of the scene node.
virtual void | setPosition (const core::vector3df &newpos)
| Sets the position of the node relative to its parent.
virtual void | setRotation (const core::vector3df &rotation)
| Sets the rotation of the node relative to its parent.
virtual void | setScale (const core::vector3df &scale)
| Sets the relative scale of the scene node.
virtual void | setTriangleSelector (ITriangleSelector *selector)
| Sets the triangle selector of the scene node.
virtual void | setVisible (bool isVisible)
| Sets if the node should be visible or not.
virtual void | updateAbsolutePosition ()
| Updates the absolute position based on the relative and the parents position.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::scene::ISceneNode
void | cloneMembers (ISceneNode *toCopyFrom, ISceneManager *newManager)
| A clone function for the ISceneNode members.
void | setSceneManager (ISceneManager *newManager)
Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.
Protected Attributes inherited from irr::scene::ISceneNode
core::matrix4 | AbsoluteTransformation
| Absolute transformation of the node.
core::list< ISceneNodeAnimator * > | Animators
| List of all animator nodes.
u32 | AutomaticCullingState
| Automatic culling state.
core::list< ISceneNode * > | Children
| List of all children of this node.
u32 | DebugDataVisible
| Flag if debug data should be drawn, such as Bounding Boxes.
s32 | ID
| ID of the node.
bool | IsDebugObject
| Is debug object?
bool | IsVisible
| Is the node visible?
core::stringc | Name
| Name of the scene node.
ISceneNode * | Parent
| Pointer to the parent.
core::vector3df | RelativeRotation
| Relative rotation of the scene node.
core::vector3df | RelativeScale
| Relative scale of the scene node.
core::vector3df | RelativeTranslation
| Relative translation of the scene node.
ISceneManager * | SceneManager
| Pointer to the scene manager.
ITriangleSelector * | TriangleSelector
| Pointer to the triangle selector.

## Detailed Description

A scene node for displaying terrain using the geo mip map algorithm.

The code for the TerrainSceneNode is based on the Terrain renderer by Soconne and the GeoMipMapSceneNode developed by Spintz. They made their code available for Irrlicht and allowed it to be distributed under this licence. I only modified some parts. A lot of thanks go to them.

This scene node is capable of very quickly loading terrains and updating the indices at runtime to enable viewing very large terrains. It uses a CLOD (Continuous Level of Detail) algorithm which updates the indices for each patch based on a LOD (Level of Detail) which is determined based on a patch's distance from the camera.

The Patch Size of the terrain must always be a size of ( 2^N+1, i.e. 8+1(9), 16+1(17), etc. ). The MaxLOD available is directly dependent on the patch size of the terrain. LOD 0 contains all of the indices to draw all the triangles at the max detail for a patch. As each LOD goes up by 1 the step taken, in generating indices increases by - 2^LOD, so for LOD 1, the step taken is 2, for LOD 2, the step taken is 4, LOD 3 - 8, etc. The step can be no larger than the size of the patch, so having a LOD of 8, with a patch size of 17, is asking the algoritm to generate indices every 2^8 ( 256 ) vertices, which is not possible with a patch size of 17. The maximum LOD for a patch size of 17 is 2^4 ( 16 ). So, with a MaxLOD of 5, you'll have LOD 0 ( full detail ), LOD 1 ( every 2 vertices ), LOD 2 ( every 4 vertices ), LOD 3 ( every 8 vertices ) and LOD 4 ( every 16 vertices ).

Definition at line 49 of file ITerrainSceneNode.h.

## Constructor & Destructor Documentation

## ITerrainSceneNode()

irr::scene::ITerrainSceneNode::ITerrainSceneNode | ( | ISceneNode * | parent,
|  | ISceneManager * | mgr,
|  | s32 | id,
|  | const core::vector3df & | position = core::vector3df(0.0f, 0.0f, 0.0f),
|  | const core::vector3df & | rotation = core::vector3df(0.0f, 0.0f, 0.0f),
|  | const core::vector3df & | scale = core::vector3df(1.0f, 1.0f, 1.0f) )

inline

Constructor.

Definition at line 53 of file ITerrainSceneNode.h.

References irr::scene::ISceneNode::ISceneNode().

## Member Function Documentation

## getBoundingBox() [1/2]

virtual const core::aabbox3d< f32 > & irr::scene::ITerrainSceneNode::getBoundingBox | ( |  | ) | const

pure virtual

Get the bounding box of the terrain.

Returns
  The bounding box of the entire terrain.

Implements irr::scene::ISceneNode.

## getBoundingBox() [2/2]

virtual const core::aabbox3d< f32 > & irr::scene::ITerrainSceneNode::getBoundingBox | ( | s32 | patchX,
|  | s32 | patchZ ) const

pure virtual

Get the bounding box of a patch.

Returns
  The bounding box of the chosen patch.

## getCurrentLODOfPatches()

virtual s32 irr::scene::ITerrainSceneNode::getCurrentLODOfPatches | ( | core::array< s32 > & | LODs | ) | const

pure virtual

Populates an array with the CurrentLOD of each patch.

Parameters

  LODs | A reference to a core::array<s32> to hold the values

Returns
  Number of elements in the array

## getHeight()

virtual f32 irr::scene::ITerrainSceneNode::getHeight | ( | f32 | x,
|  | f32 | y ) const

pure virtual

Get height of a point of the terrain.

## getIndexCount()

virtual u32 irr::scene::ITerrainSceneNode::getIndexCount | ( |  | ) | const

pure virtual

Get the number of indices currently in the meshbuffer.

Returns
  The index count.

## getIndicesForPatch()

virtual s32 irr::scene::ITerrainSceneNode::getIndicesForPatch | ( | core::array< u32 > & | indices,
|  | s32 | patchX,
|  | s32 | patchZ,
|  | s32 | LOD = 0 )

pure virtual

Gets the indices for a specified patch at a specified Level of Detail.

Parameters

  indices | A reference to an array of u32 indices.
  patchX | Patch x coordinate.
  patchZ | Patch z coordinate.
  LOD | The level of detail to get for that patch. If -1, then get the CurrentLOD. If the CurrentLOD is set to -1, meaning it's not shown, then it will retrieve the triangles at the highest LOD (0).

Returns
  Number of indices put into the buffer.

## getMesh()

virtual IMesh * irr::scene::ITerrainSceneNode::getMesh | ( |  | ) |

pure virtual

Get pointer to the mesh.

Returns
  Pointer to the mesh.

## getMeshBufferForLOD()

virtual void irr::scene::ITerrainSceneNode::getMeshBufferForLOD | ( | IDynamicMeshBuffer & | mb,
|  | s32 | LOD = 0 ) const

pure virtual

Gets the meshbuffer data based on a specified level of detail.

Parameters

  mb | A reference to an IDynamicMeshBuffer object
  LOD | The level of detail you want the indices from.

## getRenderBuffer()

virtual IMeshBuffer * irr::scene::ITerrainSceneNode::getRenderBuffer | ( |  | ) |

pure virtual

Get pointer to the buffer used by the terrain (most users will not need this).

## getTerrainCenter()

virtual const core::vector3df & irr::scene::ITerrainSceneNode::getTerrainCenter | ( |  | ) | const

pure virtual

Get center of terrain.

## loadHeightMap()

virtual bool irr::scene::ITerrainSceneNode::loadHeightMap | ( | io::IReadFile * | file,
|  | video::SColor | vertexColor = video::SColor(255, 255, 255, 255),
|  | s32 | smoothFactor = 0 )

pure virtual

Initializes the terrain data. Loads the vertices from the heightMapFile.

The file must contain a loadable image of the heightmap. The heightmap must be square.

Parameters

  file | The file to read the image from. File is not rewinded.
  vertexColor | Color of all vertices.
  smoothFactor | Number of smoothing passes.

## loadHeightMapRAW()

virtual bool irr::scene::ITerrainSceneNode::loadHeightMapRAW | ( | io::IReadFile * | file,
|  | s32 | bitsPerPixel = 16,
|  | bool | signedData = false,
|  | bool | floatVals = false,
|  | s32 | width = 0,
|  | video::SColor | vertexColor = video::SColor(255, 255, 255, 255),
|  | s32 | smoothFactor = 0 )

pure virtual

Initializes the terrain data. Loads the vertices from the heightMapFile.

The data is interpreted as (signed) integers of the given bit size or floats (with 32bits, signed). Allowed bitsizes for integers are 8, 16, and 32. The heightmap must be square.

Parameters

  file | The file to read the RAW data from. File is not rewinded.
  bitsPerPixel | Size of data if integers used, for floats always use 32.
  signedData | Whether we use signed or unsigned ints, ignored for floats.
  floatVals | Whether the data is float or int.
  width | Width (and also Height, as it must be square) of the heightmap. Use 0 for autocalculating from the filesize.
  vertexColor | Color of all vertices.
  smoothFactor | Number of smoothing passes.

## overrideLODDistance()

virtual bool irr::scene::ITerrainSceneNode::overrideLODDistance | ( | s32 | LOD,
|  | f64 | newDistance )

pure virtual

Override the default generation of distance thresholds.

For determining the LOD a patch is rendered at. If any LOD is overridden, then the scene node will no longer apply scaling factors to these values. If you override these distances, and then apply a scale to the scene node, it is your responsibility to update the new distances to work best with your new terrain size.

## scaleTexture()

virtual void irr::scene::ITerrainSceneNode::scaleTexture | ( | f32 | scale = 1.0f,
|  | f32 | scale2 = 0.0f )

pure virtual

Scales the base texture, similar to makePlanarTextureMapping.

Parameters

  scale | The scaling amount. Values above 1.0 increase the number of time the texture is drawn on the terrain. Values below 0 will decrease the number of times the texture is drawn on the terrain. Using negative values will flip the texture, as well as still scaling it.
  scale2 | If set to 0 (default value), this will set the second texture coordinate set to the same values as in the first set. If this is another value than zero, it will scale the second texture coordinate set by this value.

## setCameraMovementDelta()

virtual void irr::scene::ITerrainSceneNode::setCameraMovementDelta | ( | f32 | delta | ) |

pure virtual

Sets the movement camera threshold.

It is used to determine when to recalculate indices for the scene node. The default value is 10.0f.

## setCameraRotationDelta()

virtual void irr::scene::ITerrainSceneNode::setCameraRotationDelta | ( | f32 | delta | ) |

pure virtual

Sets the rotation camera threshold.

It is used to determine when to recalculate indices for the scene node. The default value is 1.0f.

## setDynamicSelectorUpdate()

virtual void irr::scene::ITerrainSceneNode::setDynamicSelectorUpdate | ( | bool | bVal | ) |

pure virtual

Sets whether or not the node should dynamically update its associated selector when the geomipmap data changes.

Parameters

  bVal | Boolean value representing whether or not to update selector dynamically.

## setLODOfPatch()

virtual void irr::scene::ITerrainSceneNode::setLODOfPatch | ( | s32 | patchX,
|  | s32 | patchZ,
|  | s32 | LOD = 0 )

pure virtual

Manually sets the LOD of a patch.

Parameters

  patchX | Patch x coordinate.
  patchZ | Patch z coordinate.
  LOD | The level of detail to set the patch to.

The documentation for this class was generated from the following file:

- ITerrainSceneNode.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0